## libzstd 1.5.2+dfsg

=== debian/changelog ===
libzstd (1.5.2+dfsg-1) unstable; urgency=medium

  * New upstream release (Closes: #1008165):
    - refresh some patches:
      - 0013-skip-memory-greedy-tests
      - 0015-Skip-dev-random-tests-on-hurd
      - 0017-alpha-fbfs-st_mtime
      - 0018-kfreebsd-ftbfs-utime-now
    - update the required version in the dh_makeshlibs invocation

 -- Peter Pentchev <roam@debian.org>  Mon, 11 Apr 2022 17:50:14 +0300

=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE=1

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
export DEB_BUILD_MAINT_OPTIONS=hardening=+all

# Upstream's makefiles will respect PREFIX, and this means we avoid a patch
export PREFIX=/usr

HELP2MAN = help2man --no-info --help-option="'-h'" --no-discard-stderr
mandir := $(CURDIR)/debian/zstd/usr/share/man/man1

%:
	dh $@

DH_AUTO_CONFIGURE_OPTS :=
ifneq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	DH_AUTO_CONFIGURE_OPTS += -DZSTD_BUILD_TESTS:BOOL=OFF
endif

override_dh_auto_clean:
	dh_auto_clean
	dh_auto_clean --sourcedirectory=contrib/pzstd

override_dh_auto_build:
	dh_auto_build
	dh_auto_build --sourcedirectory=lib -- all libzstd.pc libzstd
	dh_auto_build --sourcedirectory=contrib/pzstd/ -- pzstd

override_dh_install:
	# Call d-shlibmove to comply with library packaging guide
	d-shlibmove --commit \
				--multiarch \
				--devunversioned \
				--exclude-la \
				--movedev "debian/tmp/usr/include/*" usr/include \
				--movedev "debian/tmp/usr/lib/pkgconfig/*" usr/lib/$(DEB_HOST_MULTIARCH)/pkgconfig \
				debian/tmp/usr/lib/lib*.so
	cp -r debian/libzstd1/usr debian/libzstd1-udeb/
	dh_install

override_dh_makeshlibs:
	dh_makeshlibs -plibzstd1 -V'libzstd1 (>= 1.5.2)' --add-udeb=libzstd1-udeb

override_dh_installman:
	dh_installman
	cp $(mandir)/zstd.1 $(mandir)/zstdmt.1
	$(HELP2MAN) --name='parallelised Zstandard compression, al la pigz' contrib/pzstd/pzstd \
	| perl -pe 's/(\(de\)compression\s\(default:)(\d+)(\))/$$1 All$$3/g' >$(mandir)/pzstd.1

## libzstd 1.5.4+dfsg2

=== debian/changelog ===
libzstd (1.5.4+dfsg2-5) unstable; urgency=medium

  * Add the 0021-tests-newline patch to fix a very rarely occurring bug in
    the test suite when it splits a program's output into lines.
  * Add the 0022-tests-timeout patch to try once again to fix a FTBFS
    related to the window-size test; on some platforms it can now complete,
    but it takes more than the expected one minute to do so.
    Closes: #1032592

 -- Peter Pentchev <roam@debian.org>  Sat, 18 Mar 2023 22:58:30 +0200

libzstd (1.5.4+dfsg2-4) unstable; urgency=medium

  * Replace the 0019-disable-window-resize-test patch with
    the 0019-upstream-fix-cli-tests one which should hopefully fix
    the issues that made it necessary to skip those tests.
  * Add the 0020-upstream-fix-block-splitter to fix a rare problem.
  * Explicitly override the no-versioned-debhelper-prerequisite
    Lintian tag as suggested in its description.

 -- Peter Pentchev <roam@debian.org>  Wed, 08 Mar 2023 23:54:45 +0200

libzstd (1.5.4+dfsg2-3) unstable; urgency=medium

  * Temporary disable the window-resize CLI test until I can figure out
    why does it seem to randomly fail on some of the Debian buildds.

 -- Peter Pentchev <roam@debian.org>  Mon, 13 Feb 2023 12:56:34 +0200

libzstd (1.5.4+dfsg2-2) unstable; urgency=medium

  * Fix FTBFS: add python3 and less as build-time dependencies for
    the test suite.

 -- Peter Pentchev <roam@debian.org>  Mon, 13 Feb 2023 03:55:11 +0200

libzstd (1.5.4+dfsg2-1) unstable; urgency=medium

  * Add autopkgtests that build simple programs that link to libzstd
    using the pkg-config and CMake build systems.
  * New upstream release:
    - update the upstream copyright notices
    - drop the 0019-hurd-unused patch, integrated upstream
    - refresh the patches
  * Add the year 2023 to my debian/* copyright notice.

 -- Peter Pentchev <roam@debian.org>  Mon, 13 Feb 2023 01:37:54 +0200

libzstd (1.5.2+dfsg2-3) unstable; urgency=medium

  * Add the 0019-hurd-unused patch to fix a FTBFS on the GNU Hurd:
    silence an unused parameter warning.
  * Fix FTCBFS: Export build tools for all targets. Closes: #1027126

 -- Peter Pentchev <roam@debian.org>  Thu, 29 Dec 2022 18:08:51 +0200

libzstd (1.5.2+dfsg2-2) unstable; urgency=medium

  * Fix a FTBFS on i386 (and on any arch where DEB_HOST_MULTIARCH is not
    the same as DEB_HOST_GNU_TYPE).
  * Correctly point the debhelper cmake tools to build/cmake/ as
    the source directory instead of passing it as a positional argument
    that is not expected by Buildsystem::cmake.

 -- Peter Pentchev <roam@debian.org>  Tue, 27 Dec 2022 22:54:45 +0200

libzstd (1.5.2+dfsg2-1) unstable; urgency=medium

  * Declare compliance with Policy 4.6.2 with no changes.
  * Use the GitHub API in the watch file.
  * Build and distribute the CMake build glue files:
    - Closes: #1020403
    - repack with the build/cmake/ and build/meson/ directories
    - add an explicit "build" target to the rules file that invokes
      `dh build` to make sure that make(1) does not mistake the existence of
      the build/ directory for "nothing to do"
    - run an additional `dh_auto_configure` with `--buildsystem-cmake` to
      generate the zstdConfig*.cmake and zstdTarget*.cmake files used by
      other projects to link against libzstd
    - use debhelper compat level 14 for the CMake support
    - install the CMake build glue files
    - enable the ZSTD_LEGACY_SUPPORT CMake config option so that
      the CMake build does not differ in behavior from the Makefile one
  * Add Rules-Requires-Root: no to the source package stanza.
  * Do not use d-shlibs, debhelper's tools can do the job.
  * Use `execute_after_dh_installman` instead of overriding the full target.
  * Improve the pzstd manual page's title ("parallelised" -> "parallelized",
    "al la" -> "a la").
  * Pass V=1 to `make` unless the "terse" build option is set. Closes: #1009746
  * Fix the source licensing: BSD *or* GPL-2, not "and". Closes: #1012003
  * Mark the zstd binary package as Multi-Arch: foreign. Closes: #1014438
  * Support the noudeb build profile. Closes: #1024937

 -- Peter Pentchev <roam@debian.org>  Tue, 27 Dec 2022 19:47:09 +0200

=== debian/control ===
Source: libzstd
Maintainer: RPM packaging team <team+pkg-rpm@tracker.debian.org>
Uploaders: Peter Pentchev <roam@debian.org>
Section: libs
Priority: optional
Build-Depends: cmake,
               debhelper (>> 13.3.2~),
               help2man,
               liblz4-dev,
               liblzma-dev,
               zlib1g-dev,
               less <!nocheck>,
               python3 <!nocheck>,
Standards-Version: 4.6.2
Vcs-Browser: https://salsa.debian.org/pkg-rpm-team/libzstd
Vcs-Git: https://salsa.debian.org/pkg-rpm-team/libzstd.git
Homepage: https://github.com/facebook/zstd
Rules-Requires-Root: no

Package: libzstd-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libzstd1 (= ${binary:Version}),
         ${misc:Depends}
Description: fast lossless compression algorithm -- development files
 Zstd, short for Zstandard, is a fast lossless compression algorithm, targeting
 real-time compression scenarios at zlib-level compression ratio.
 .
 This package contains the headers and static library.

Package: libzstd1
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: fast lossless compression algorithm
 Zstd, short for Zstandard, is a fast lossless compression algorithm, targeting
 real-time compression scenarios at zlib-level compression ratio.
 .
 This package contains the shared library.

Package: zstd
Architecture: any
Multi-Arch: foreign
Section: utils
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: fast lossless compression algorithm -- CLI tool
 Zstd, short for Zstandard, is a fast lossless compression algorithm, targeting
 real-time compression scenarios at zlib-level compression ratio.
 .
 This package contains the CLI program implementing zstd.

Package: libzstd1-udeb
Architecture: any
Section: debian-installer
Depends: ${misc:Depends},
         ${shlibs:Depends}
Package-Type: udeb
Build-Profiles: <!noudeb>
Description: fast lossless compression algorithm library for debian-installer

=== debian/rules ===
#!/usr/bin/make -f

# Export build tools for all targets to avoid build hash changes.
DPKG_EXPORT_BUILDTOOLS=1
include /usr/share/dpkg/buildtools.mk

export DH_VERBOSE=1

arch ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
export DEB_BUILD_MAINT_OPTIONS=hardening=+all

# Upstream's makefiles will respect PREFIX, and this means we avoid a patch
export PREFIX=/usr

HELP2MAN = help2man --no-info --help-option="'-h'" --no-discard-stderr
mandir := $(CURDIR)/debian/zstd/usr/share/man/man1

DH_AUTO_CONFIGURE_OPTS := \
	-DCMAKE_LIBRARY_ARCHITECTURE=${arch} \
	-DZSTD_LEGACY_SUPPORT:BOOL=ON \

ifneq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	DH_AUTO_CONFIGURE_OPTS += -DBUILD_TESTING:BOOL=OFF
else
	DH_AUTO_CONFIGURE_OPTS += -DBUILD_TESTING:BOOL=ON
endif

ifeq (,$(filter terse,$(DEB_BUILD_OPTIONS)))
# Verbose output for the default 'make' build system
export V=1
endif

%:
	dh '$@'

execute_after_dh_auto_clean:
	dh_auto_clean -D contrib/pzstd
	dh_auto_clean -D doc/educational_decoder
	dh_auto_clean \
		--buildsystem=cmake \
		--sourcedir=$(CURDIR)/build/cmake

execute_after_dh_auto_configure:
	dh_auto_configure \
		--buildsystem=cmake \
		--sourcedir=$(CURDIR)/build/cmake \
		-- \
		$(DH_CMAKE_CONFIGURE_OPTS)

execute_after_dh_auto_build:
	dh_auto_build -D contrib/pzstd

override_dh_auto_install:
	dh_auto_install -- libdir=/usr/lib/$(arch)
	dh_auto_install -D contrib/pzstd

ifeq (,$(filter noudeb,$(DEB_BUILD_PROFILES)))
execute_after_dh_install:
	cp -r debian/libzstd1/usr debian/libzstd1-udeb/
endif

override_dh_makeshlibs:
	dh_makeshlibs -plibzstd1 -V'libzstd1 (>= 1.5.2)' --add-udeb=libzstd1-udeb

execute_after_dh_installman:
	cp $(mandir)/zstd.1 $(mandir)/zstdmt.1
	$(HELP2MAN) --name='parallelized Zstandard compression, a la pigz' contrib/pzstd/pzstd \
	| perl -pe 's/(\(de\)compression\s\(default:)(\d+)(\))/$$1 All$$3/g' >$(mandir)/pzstd.1

build:
	dh $@

.PHONY: build

=== debian/watch ===
version=4

opts="searchmode=plain,repacksuffix=+dfsg2,dversionmangle=s/\+dfsg\d*//g,repack,compression=xz" \
  https://api.github.com/repos/facebook/zstd/releases https://github.com/[^"']*/zstd-@ANY_VERSION@@ARCHIVE_EXT@

## libzstd 1.5.5+dfsg2

=== build/cmake/lib/CMakeLists.txt ===
# ################################################################
# Copyright (c) Meta Platforms, Inc. and affiliates.
# All rights reserved.
#
# This source code is licensed under both the BSD-style license (found in the
# LICENSE file in the root directory of this source tree) and the GPLv2 (found
# in the COPYING file in the root directory of this source tree).
# ################################################################

project(libzstd C ASM)

set(CMAKE_INCLUDE_CURRENT_DIR TRUE)
option(ZSTD_BUILD_STATIC "BUILD STATIC LIBRARIES" ON)
option(ZSTD_BUILD_SHARED "BUILD SHARED LIBRARIES" ON)

if(NOT ZSTD_BUILD_SHARED AND NOT ZSTD_BUILD_STATIC)
    message(SEND_ERROR "You need to build at least one flavor of libzstd")
endif()

# Define library directory, where sources and header files are located
include_directories(${LIBRARY_DIR} ${LIBRARY_DIR}/common)

file(GLOB CommonSources ${LIBRARY_DIR}/common/*.c)
file(GLOB CompressSources ${LIBRARY_DIR}/compress/*.c)
if (MSVC)
    file(GLOB DecompressSources ${LIBRARY_DIR}/decompress/*.c)
    add_compile_options(-DZSTD_DISABLE_ASM)
else ()
    file(GLOB DecompressSources ${LIBRARY_DIR}/decompress/*.c ${LIBRARY_DIR}/decompress/*.S)
endif ()
file(GLOB DictBuilderSources ${LIBRARY_DIR}/dictBuilder/*.c)

set(Sources
        ${CommonSources}
        ${CompressSources}
        ${DecompressSources}
        ${DictBuilderSources})

file(GLOB CommonHeaders ${LIBRARY_DIR}/common/*.h)
file(GLOB CompressHeaders ${LIBRARY_DIR}/compress/*.h)
file(GLOB DecompressHeaders ${LIBRARY_DIR}/decompress/*.h)
file(GLOB DictBuilderHeaders ${LIBRARY_DIR}/dictBuilder/*.h)

set(Headers
        ${LIBRARY_DIR}/zstd.h
        ${CommonHeaders}
        ${CompressHeaders}
        ${DecompressHeaders}
        ${DictBuilderHeaders})

if (ZSTD_LEGACY_SUPPORT)
    set(LIBRARY_LEGACY_DIR ${LIBRARY_DIR}/legacy)
    include_directories(${LIBRARY_LEGACY_DIR})

    set(Sources ${Sources}
            ${LIBRARY_LEGACY_DIR}/zstd_v01.c
            ${LIBRARY_LEGACY_DIR}/zstd_v02.c
            ${LIBRARY_LEGACY_DIR}/zstd_v03.c
            ${LIBRARY_LEGACY_DIR}/zstd_v04.c
            ${LIBRARY_LEGACY_DIR}/zstd_v05.c
            ${LIBRARY_LEGACY_DIR}/zstd_v06.c
            ${LIBRARY_LEGACY_DIR}/zstd_v07.c)

    set(Headers ${Headers}
            ${LIBRARY_LEGACY_DIR}/zstd_legacy.h
            ${LIBRARY_LEGACY_DIR}/zstd_v01.h
            ${LIBRARY_LEGACY_DIR}/zstd_v02.h
            ${LIBRARY_LEGACY_DIR}/zstd_v03.h
            ${LIBRARY_LEGACY_DIR}/zstd_v04.h
            ${LIBRARY_LEGACY_DIR}/zstd_v05.h
            ${LIBRARY_LEGACY_DIR}/zstd_v06.h
            ${LIBRARY_LEGACY_DIR}/zstd_v07.h)
endif ()

if (MSVC)
    set(MSVC_RESOURCE_DIR ${ZSTD_SOURCE_DIR}/build/VS2010/libzstd-dll)
    set(PlatformDependResources ${MSVC_RESOURCE_DIR}/libzstd-dll.rc)
endif ()

# Explicitly set the language to C for all files, including ASM files.
# Our assembly expects to be compiled by a C compiler, and is only enabled for
# __GNUC__ compatible compilers. Otherwise all the ASM code is disabled by
# macros.
set_source_files_properties(${Sources} PROPERTIES LANGUAGE C)

# Split project to static and shared libraries build
set(library_targets)
if (ZSTD_BUILD_SHARED)
    add_library(libzstd_shared SHARED ${Sources} ${Headers} ${PlatformDependResources})
    list(APPEND library_targets libzstd_shared)
    if (ZSTD_MULTITHREAD_SUPPORT)
        set_property(TARGET libzstd_shared APPEND PROPERTY COMPILE_DEFINITIONS "ZSTD_MULTITHREAD")
        if (UNIX)
            target_link_libraries(libzstd_shared ${THREADS_LIBS})
        endif ()
    endif()
endif ()
if (ZSTD_BUILD_STATIC)
    add_library(libzstd_static STATIC ${Sources} ${Headers})
    list(APPEND library_targets libzstd_static)
    if (ZSTD_MULTITHREAD_SUPPORT)
        set_property(TARGET libzstd_static APPEND PROPERTY COMPILE_DEFINITIONS "ZSTD_MULTITHREAD")
        if (UNIX)
            target_link_libraries(libzstd_static ${THREADS_LIBS})
        endif ()
    endif ()
endif ()

# Add specific compile definitions for MSVC project
if (MSVC)
    if (ZSTD_BUILD_SHARED)
        set_property(TARGET libzstd_shared APPEND PROPERTY COMPILE_DEFINITIONS "ZSTD_DLL_EXPORT=1;ZSTD_HEAPMODE=0;_CONSOLE;_CRT_SECURE_NO_WARNINGS")
    endif ()
    if (ZSTD_BUILD_STATIC)
        set_property(TARGET libzstd_static APPEND PROPERTY COMPILE_DEFINITIONS "ZSTD_HEAPMODE=0;_CRT_SECURE_NO_WARNINGS")
    endif ()
endif ()

# With MSVC static library needs to be renamed to avoid conflict with import library
if (MSVC OR (WIN32 AND CMAKE_CXX_COMPILER_ID STREQUAL "Clang" AND NOT MINGW))
    set(STATIC_LIBRARY_BASE_NAME zstd_static)
else ()
    set(STATIC_LIBRARY_BASE_NAME zstd)
endif ()

# Define static and shared library names
if (ZSTD_BUILD_SHARED)
    set_target_properties(
            libzstd_shared
            PROPERTIES
            OUTPUT_NAME zstd
            VERSION ${zstd_VERSION_MAJOR}.${zstd_VERSION_MINOR}.${zstd_VERSION_PATCH}
            SOVERSION ${zstd_VERSION_MAJOR})
endif ()

if (ZSTD_BUILD_STATIC)
    set_target_properties(
            libzstd_static
            PROPERTIES
            POSITION_INDEPENDENT_CODE On
            OUTPUT_NAME ${STATIC_LIBRARY_BASE_NAME})
endif ()

# pkg-config
include(JoinPaths) # can be replaced by cmake_path(APPEND) in CMake 3.20
set(PREFIX "${CMAKE_INSTALL_PREFIX}")
set(EXEC_PREFIX "\${prefix}")
join_paths(LIBDIR "\${exec_prefix}" "${CMAKE_INSTALL_LIBDIR}")
join_paths(INCLUDEDIR "\${prefix}" "${CMAKE_INSTALL_INCLUDEDIR}")
set(LIBS_PRIVATE "${THREADS_LIBS}")
set(VERSION "${zstd_VERSION}")

configure_file("${LIBRARY_DIR}/libzstd.pc.in" "${CMAKE_CURRENT_BINARY_DIR}/libzstd.pc" @ONLY)
install(FILES "${CMAKE_CURRENT_BINARY_DIR}/libzstd.pc" DESTINATION "${CMAKE_INSTALL_LIBDIR}/pkgconfig")

# install target
install(FILES
    "${LIBRARY_DIR}/zstd.h"
    "${LIBRARY_DIR}/zdict.h"
    "${LIBRARY_DIR}/zstd_errors.h"
    DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}")

install(TARGETS ${library_targets}
    EXPORT zstdExports
    INCLUDES DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}"
    ARCHIVE DESTINATION "${CMAKE_INSTALL_LIBDIR}"
    LIBRARY DESTINATION "${CMAKE_INSTALL_LIBDIR}"
    RUNTIME DESTINATION "${CMAKE_INSTALL_BINDIR}"
    BUNDLE DESTINATION "${CMAKE_INSTALL_BINDIR}"
    )

# uninstall target
if (NOT TARGET uninstall)
    configure_file(
            "${CMAKE_CURRENT_SOURCE_DIR}/cmake_uninstall.cmake.in"
            "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
            IMMEDIATE @ONLY)

    add_custom_target(uninstall
            COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake)
endif ()

=== debian/changelog ===
libzstd (1.5.5+dfsg2-2build1) noble; urgency=high

  * No change rebuild for 64-bit time_t and frame pointers.

 -- Julian Andres Klode <juliank@ubuntu.com>  Mon, 08 Apr 2024 18:10:50 +0200

libzstd (1.5.5+dfsg2-2) unstable; urgency=medium

  * Clean up a directory of symlinks created by the test suite.
    Closes: #1049066
  * Bump the CMake version requirement to 3.24. Closes: #1031384
  * Fix the nodoc build: do not tweak non-existent manpages. Closes: #1037088
  * Declare version 1 of the dpkg-build API:
    - drop the implied Root-Requires-Root: true
    - use dpkg's default.mk instead of including buildtools.mk directly
  * Use the DEB_HOST_MULTIARCH variable provided by default.mk.
  * Use dh-package-notes to record ELF package metadata.
  * Update the bundled copy of the check-build Python library in
    the autopkgtest tree:
    - remove the non-runtime check-build files
    - import check-build 0.1.0

 -- Peter Pentchev <roam@debian.org>  Sun, 17 Sep 2023 16:48:35 +0300

libzstd (1.5.5+dfsg2-1) unstable; urgency=medium

  * Do not detect -win64 versions in the watch file.
  * New upstream release:
    - Closes: #1038728
    - drop the 0019-upstream-fix-cli-tests, 0020-upstream-fix-block-splitter,
      and 0021-tests-newline patches, they were taken from upstream
    - adapt the 0022-tests-timeout patch to the new upstream default
      timeout (which was raised, but not enough)
    - update the required version in the dh_makeshlibs invocation
  * Add the 0023-cmake-min-3.13 Debian-specific patch to bump the minimum
    required CMake version to 3.13.4.

 -- Peter Pentchev <roam@debian.org>  Sun, 25 Jun 2023 00:37:36 +0300

=== debian/tests/control ===
Test-Command: zstd -b1 >/dev/null 2>&1
Features: test-name=zstd-selftest

Test-Command: env PYTHONPATH="$(pwd)/debian/tests/python" python3 -B -u -m check_build -c debian/tests/ztest/programs.toml -v -- pkg-make
Depends:
 @,
 build-essential,
 pkgconf,
 python3,
 python3-click,
 python3-typedload,
Restrictions: allow-stderr
Features: test-name=build-pkg-config

Test-Command: env PYTHONPATH="$(pwd)/debian/tests/python" python3 -B -u -m check_build -c debian/tests/ztest/programs.toml -v -- cmake
Depends:
 @,
 build-essential,
 cmake,
 python3,
 python3-click,
 python3-typedload,
Restrictions: allow-stderr
Features: test-name=build-cmake

=== debian/watch ===
version=4

opts="searchmode=plain,repacksuffix=+dfsg2,dversionmangle=s/\+dfsg\d*//g,repack,compression=xz" \
  https://api.github.com/repos/facebook/zstd/releases https://github.com/[^"']*/zstd-(\d[\d.]+)@ARCHIVE_EXT@

## libzstd 1.5.5+dfsg2-2build1.1trisquel1

=== zlibWrapper/Makefile ===
# Makefile for example of using zstd wrapper for zlib
#
# make - compiles examples
# make MOREFLAGS=-DZWRAP_USE_ZSTD=1 - compiles examples with zstd compression turned on
# make test - runs examples


# Paths to static and dynamic zlib and zstd libraries
# Use "make ZLIB_PATH=path/to/zlib ZLIB_LIBRARY=path/to/libz.so" to select a path to library
ZLIB_LIBRARY ?= -lz
ZLIB_PATH ?= .

ZSTDLIBDIR = ../lib
ZSTDLIBRARY = $(ZSTDLIBDIR)/libzstd.a
ZLIBWRAPPER_PATH = .
#GZFILES = gzclose.o gzlib.o gzread.o gzwrite.o
EXAMPLE_PATH = examples
PROGRAMS_PATH = ../programs
TEST_FILE = ../doc/zstd_compression_format.md

vpath %.c $(PROGRAMS_PATH) $(EXAMPLE_PATH) $(ZLIBWRAPPER_PATH)


CPPFLAGS += -DXXH_NAMESPACE=ZSTD_ -I$(ZLIB_PATH) -I$(PROGRAMS_PATH)       \
            -I$(ZSTDLIBDIR) -I$(ZSTDLIBDIR)/common -I$(ZLIBWRAPPER_PATH)
STDFLAGS  = -std=c89 -pedantic -Wno-long-long -Wno-variadic-macros -Wc++-compat \
            -DNO_snprintf -DNO_vsnprintf  # strict ANSI C89 is missing these prototypes
DEBUGFLAGS= -Wall -Wextra -Wcast-qual -Wcast-align -Wshadow -Wswitch-enum \
            -Wdeclaration-after-statement -Wstrict-prototypes -Wundef     \
            -Wstrict-aliasing=1
CFLAGS   ?= -O3
CFLAGS   += $(STDFLAGS) $(DEBUGFLAGS)
CPPFLAGS += $(MOREFLAGS)
LDLIBS   += $(ZLIB_LIBRARY)

# Define *.exe as extension for Windows systems
ifneq (,$(filter Windows%,$(OS)))
EXT =.exe
else
EXT =
endif

default : release

release : STDFLAGS =
release : DEBUGFLAGS =
release : all

all: fitblk example zwrapbench minigzip

test: example fitblk example_zstd fitblk_zstd zwrapbench minigzip minigzip_zstd
	./example
	./example_zstd
	./fitblk 10240 <$(TEST_FILE)
	./fitblk 40960 <$(TEST_FILE)
	./fitblk_zstd 10240 <$(TEST_FILE)
	./fitblk_zstd 40960 <$(TEST_FILE)
	@echo ---- minigzip start ----
	./minigzip_zstd example$(EXT)
	#cp example$(EXT).gz example$(EXT)_zstd.gz
	./minigzip_zstd -d example$(EXT).gz
	./minigzip example$(EXT)
	#cp example$(EXT).gz example$(EXT)_gz.gz
	./minigzip_zstd -d example$(EXT).gz
	@echo ---- minigzip end ----
	./zwrapbench -qi1b3B1K $(TEST_FILE)
	./zwrapbench -rqi1b1e3 ../lib

.PHONY: test-valgrind
#test-valgrind: ZSTDLIBRARY = $(ZSTDLIBDIR)/libzstd.so
test-valgrind: VALGRIND = LD_LIBRARY_PATH=$(ZSTDLIBDIR) valgrind --track-origins=yes --leak-check=full --error-exitcode=1
test-valgrind: clean example fitblk example_zstd fitblk_zstd zwrapbench
	@echo "\n ---- valgrind tests ----"
	$(VALGRIND) ./example
	$(VALGRIND) ./example_zstd
	$(VALGRIND) ./fitblk 10240 <$(TEST_FILE)
	$(VALGRIND) ./fitblk 40960 <$(TEST_FILE)
	$(VALGRIND) ./fitblk_zstd 10240 <$(TEST_FILE)
	$(VALGRIND) ./fitblk_zstd 40960 <$(TEST_FILE)
	$(VALGRIND) ./zwrapbench -qi1b3B1K $(TEST_FILE)
	$(VALGRIND) ./zwrapbench -rqi1b1e5 ../lib ../programs ../tests

#.c.o:
#	$(CC) $(CFLAGS) $(CPPFLAGS) -c $< -o $@

minigzip: minigzip.o zstd_zlibwrapper.o $(ZSTDLIBRARY)

minigzip_zstd: minigzip.o zstdTurnedOn_zlibwrapper.o $(ZSTDLIBRARY)
	$(LINK.o) $^ $(LDLIBS) $(OUTPUT_OPTION)

example: example.o zstd_zlibwrapper.o $(ZSTDLIBRARY)

example_zstd: example.o zstdTurnedOn_zlibwrapper.o $(ZSTDLIBRARY)
	$(LINK.o) $^ $(LDLIBS) $(OUTPUT_OPTION)

fitblk: fitblk.o zstd_zlibwrapper.o $(ZSTDLIBRARY)

fitblk_zstd: fitblk.o zstdTurnedOn_zlibwrapper.o $(ZSTDLIBRARY)
	$(LINK.o) $^ $(LDLIBS) $(OUTPUT_OPTION)

zwrapbench: zwrapbench.o zstd_zlibwrapper.o util.o timefn.o datagen.o $(ZSTDLIBRARY)


zstd_zlibwrapper.o: zstd_zlibwrapper.h

zstdTurnedOn_zlibwrapper.o: CPPFLAGS += -DZWRAP_USE_ZSTD=1
zstdTurnedOn_zlibwrapper.o: zstd_zlibwrapper.c zstd_zlibwrapper.h
	$(COMPILE.c) $< $(OUTPUT_OPTION)


$(ZSTDLIBRARY):
	$(MAKE) -C $(ZSTDLIBDIR) libzstd.a

$(ZSTDLIBDIR)/libzstd.so:
	$(MAKE) -C $(ZSTDLIBDIR) libzstd


clean:
	-$(RM) $(ZLIBWRAPPER_PATH)/*.o $(EXAMPLE_PATH)/*.o *.o foo.gz example$(EXT) example_zstd$(EXT) fitblk$(EXT) fitblk_zstd$(EXT) zwrapbench$(EXT) minigzip$(EXT) minigzip_zstd$(EXT)
	@echo Cleaning completed

=== build/cmake/CMakeLists.txt ===
# ################################################################
# Copyright (c) Meta Platforms, Inc. and affiliates.
# All rights reserved.
#
# This source code is licensed under both the BSD-style license (found in the
# LICENSE file in the root directory of this source tree) and the GPLv2 (found
# in the COPYING file in the root directory of this source tree).
# ################################################################

cmake_minimum_required(VERSION 3.24.0 FATAL_ERROR)

# As of 2018-12-26 ZSTD has been validated to build with cmake version 3.13.2 new policies.
# Set and use the newest cmake policies that are validated to work
set(ZSTD_MAX_VALIDATED_CMAKE_MAJOR_VERSION "3")
set(ZSTD_MAX_VALIDATED_CMAKE_MINOR_VERSION "13") #Policies never changed at PATCH level
if("${CMAKE_MAJOR_VERSION}" LESS 3)
  set(ZSTD_CMAKE_POLICY_VERSION "${CMAKE_VERSION}")
elseif( "${ZSTD_MAX_VALIDATED_CMAKE_MAJOR_VERSION}" EQUAL "${CMAKE_MAJOR_VERSION}" AND
        "${ZSTD_MAX_VALIDATED_CMAKE_MINOR_VERSION}" GREATER "${CMAKE_MINOR_VERSION}")
    set(ZSTD_CMAKE_POLICY_VERSION "${CMAKE_VERSION}")
else()
    set(ZSTD_CMAKE_POLICY_VERSION "${ZSTD_MAX_VALIDATED_CMAKE_MAJOR_VERSION}.${ZSTD_MAX_VALIDATED_CMAKE_MINOR_VERSION}.0")
endif()
cmake_policy(VERSION ${ZSTD_CMAKE_POLICY_VERSION})

set(CMAKE_BUILD_WITH_INSTALL_RPATH on)

list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/CMakeModules")
set(ZSTD_SOURCE_DIR "${CMAKE_CURRENT_SOURCE_DIR}/../..")
set(LIBRARY_DIR ${ZSTD_SOURCE_DIR}/lib)
# Parse version
include(GetZstdLibraryVersion)
GetZstdLibraryVersion(${LIBRARY_DIR}/zstd.h zstd_VERSION_MAJOR zstd_VERSION_MINOR zstd_VERSION_PATCH)

if( CMAKE_MAJOR_VERSION LESS 3 )
  ## Provide cmake 3+ behavior for older versions of cmake
  project(zstd)
  set(PROJECT_VERSION_MAJOR ${zstd_VERSION_MAJOR})
  set(PROJECT_VERSION_MINOR ${zstd_VERSION_MINOR})
  set(PROJECT_VERSION_PATCH ${zstd_VERSION_PATCH})
  set(PROJECT_VERSION "${zstd_VERSION_MAJOR}.${zstd_VERSION_MINOR}.${zstd_VERSION_PATCH}")
  enable_language(C)   # Main library is in C
  enable_language(ASM) # And ASM
  enable_language(CXX) # Testing contributed code also utilizes CXX
else()
  project(zstd
    VERSION "${zstd_VERSION_MAJOR}.${zstd_VERSION_MINOR}.${zstd_VERSION_PATCH}"
    LANGUAGES C   # Main library is in C
              ASM # And ASM
              CXX # Testing contributed code also utilizes CXX
    )
endif()
message(STATUS "ZSTD VERSION: ${zstd_VERSION}")
set(zstd_HOMEPAGE_URL "https://facebook.github.io/zstd")
set(zstd_DESCRIPTION  "Zstandard is a real-time compression algorithm, providing high compression ratios.")

# Set a default build type if none was specified
if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
  message(STATUS "Setting build type to 'Release' as none was specified.")
  set(CMAKE_BUILD_TYPE Release CACHE STRING "Choose the type of build." FORCE)
  # Set the possible values of build type for cmake-gui
  set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS "Debug" "Release" "MinSizeRel" "RelWithDebInfo")
endif()

include(GNUInstallDirs)

#-----------------------------------------------------------------------------
# Add extra compilation flags
#-----------------------------------------------------------------------------
include(AddZstdCompilationFlags)
ADD_ZSTD_COMPILATION_FLAGS()

# Always hide XXHash symbols
add_definitions(-DXXH_NAMESPACE=ZSTD_)

#-----------------------------------------------------------------------------
# Installation variables
#-----------------------------------------------------------------------------
message(STATUS "CMAKE_INSTALL_PREFIX: ${CMAKE_INSTALL_PREFIX}")
message(STATUS "CMAKE_INSTALL_LIBDIR: ${CMAKE_INSTALL_LIBDIR}")

#-----------------------------------------------------------------------------
# Options
#-----------------------------------------------------------------------------

# Legacy support
option(ZSTD_LEGACY_SUPPORT "LEGACY SUPPORT" ON)

if (ZSTD_LEGACY_SUPPORT)
    message(STATUS "ZSTD_LEGACY_SUPPORT defined!")
    set(ZSTD_LEGACY_LEVEL 5 CACHE STRING "")
    add_definitions(-DZSTD_LEGACY_SUPPORT=${ZSTD_LEGACY_LEVEL})
else ()
    message(STATUS "ZSTD_LEGACY_SUPPORT not defined!")
    add_definitions(-DZSTD_LEGACY_SUPPORT=0)
endif ()

if (ANDROID)
    set(ZSTD_MULTITHREAD_SUPPORT_DEFAULT OFF)
else()
    set(ZSTD_MULTITHREAD_SUPPORT_DEFAULT ON)
endif()

# Multi-threading support
option(ZSTD_MULTITHREAD_SUPPORT "MULTITHREADING SUPPORT" ${ZSTD_MULTITHREAD_SUPPORT_DEFAULT})

if (ZSTD_MULTITHREAD_SUPPORT)
    message(STATUS "ZSTD_MULTITHREAD_SUPPORT is enabled")
else ()
    message(STATUS "ZSTD_MULTITHREAD_SUPPORT is disabled")
endif ()

option(ZSTD_BUILD_PROGRAMS "BUILD PROGRAMS" ON)
option(ZSTD_BUILD_CONTRIB "BUILD CONTRIB" OFF)

# Respect the conventional CMake option for enabling tests if it was specified on the first configure
if (BUILD_TESTING)
    set(ZSTD_BUILD_TESTS_default ON)
else()
    set(ZSTD_BUILD_TESTS_default OFF)
endif()
option(ZSTD_BUILD_TESTS "BUILD TESTS" ${ZSTD_BUILD_TESTS_default})
if (MSVC)
    option(ZSTD_USE_STATIC_RUNTIME "LINK TO STATIC RUN-TIME LIBRARIES" OFF)
endif ()

#-----------------------------------------------------------------------------
# External dependencies
#-----------------------------------------------------------------------------
if (ZSTD_MULTITHREAD_SUPPORT AND UNIX)
    set(THREADS_PREFER_PTHREAD_FLAG ON)
    find_package(Threads REQUIRED)
    if(CMAKE_USE_PTHREADS_INIT)
        set(THREADS_LIBS "${CMAKE_THREAD_LIBS_INIT}")
    else()
        message(SEND_ERROR "ZSTD currently does not support thread libraries other than pthreads")
    endif()
endif ()

#-----------------------------------------------------------------------------
# Add source directories
#-----------------------------------------------------------------------------
add_subdirectory(lib)

option(ZSTD_PROGRAMS_LINK_SHARED "PROGRAMS LINK SHARED" OFF)

if (ZSTD_BUILD_PROGRAMS)
    if (NOT ZSTD_BUILD_STATIC AND NOT ZSTD_PROGRAMS_LINK_SHARED)
        message(SEND_ERROR "You need to build static library to build zstd CLI")
    elseif(NOT ZSTD_BUILD_SHARED AND ZSTD_PROGRAMS_LINK_SHARED)
        message(SEND_ERROR "You need to build shared library to build zstd CLI")
    endif ()

    add_subdirectory(programs)
endif ()

if (ZSTD_BUILD_TESTS)
    enable_testing()
    if (NOT ZSTD_BUILD_STATIC)
        message(SEND_ERROR "You need to build static library to build tests")
    endif ()

    add_subdirectory(tests)
endif ()

if (ZSTD_BUILD_CONTRIB)
    add_subdirectory(contrib)
endif ()

#-----------------------------------------------------------------------------
# Add clean-all target
#-----------------------------------------------------------------------------
add_custom_target(clean-all
   COMMAND ${CMAKE_BUILD_TOOL} clean
   COMMAND rm -rf ${CMAKE_BINARY_DIR}/
)

#-----------------------------------------------------------------------------
# Generate Package Config files
#
# This section is based on the boiler plate code from:
# https://cmake.org/cmake/help/latest/manual/cmake-packages.7.html#creating-packages
#-----------------------------------------------------------------------------
include(CMakePackageConfigHelpers)
write_basic_package_version_file(
    "${CMAKE_CURRENT_BINARY_DIR}/zstdConfigVersion.cmake"
    VERSION ${zstd_VERSION}
    COMPATIBILITY SameMajorVersion
    )

# A Package Config file that works from the build directory
export(EXPORT zstdExports
    FILE "${CMAKE_CURRENT_BINARY_DIR}/zstdTargets.cmake"
    NAMESPACE zstd::
    )
configure_file(zstdConfig.cmake
    "${CMAKE_CURRENT_BINARY_DIR}/zstdConfig.cmake"
    COPYONLY
    )

# A Package Config file that works from the installation directory
set(ConfigPackageLocation ${CMAKE_INSTALL_LIBDIR}/cmake/zstd)
install(EXPORT zstdExports
    FILE zstdTargets.cmake
    NAMESPACE zstd::
    DESTINATION ${ConfigPackageLocation}
    )
install(FILES
    zstdConfig.cmake
    "${CMAKE_CURRENT_BINARY_DIR}/zstdConfigVersion.cmake"
    DESTINATION ${ConfigPackageLocation}
    )

=== debian/changelog ===
libzstd (1.5.5+dfsg2-2build1.1trisquel1) ecne; urgency=medium

  * Rebuild upstream to get udeb dependency for debian-installer.

 -- Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>  Wed, 25 Sep 2024 17:37:47 +0000

libzstd (1.5.5+dfsg2-2build1.1) noble-proposed; urgency=medium

  * SRU: LP: #2076340: No-change rebuild to pick up changed build flags
    on ppc64 and s390x.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 09 Aug 2024 04:33:22 +0200

=== debian/control ===
--- 
+++ 
@@ -1,10 +1,13 @@
 Source: libzstd
-Maintainer: RPM packaging team <team+pkg-rpm@tracker.debian.org>
+Maintainer: Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>
+XSBC-Original-Maintainer: RPM packaging team <team+pkg-rpm@tracker.debian.org>
 Uploaders: Peter Pentchev <roam@debian.org>
 Section: libs
 Priority: optional
-Build-Depends: cmake,
+Build-Depends: cmake (>= 3.24~),
                debhelper (>> 13.3.2~),
+               dh-package-notes,
+               dpkg-build-api (= 1),
                help2man,
                liblz4-dev,
                liblzma-dev,
@@ -15,7 +18,6 @@
 Vcs-Browser: https://salsa.debian.org/pkg-rpm-team/libzstd
 Vcs-Git: https://salsa.debian.org/pkg-rpm-team/libzstd.git
 Homepage: https://github.com/facebook/zstd
-Rules-Requires-Root: no
 
 Package: libzstd-dev
 Architecture: any

## libzstd 1.5.6%2Bdfsg

=== debian/changelog ===
libzstd (1.5.6+dfsg-1) unstable; urgency=medium

  * Add the 0024-no-lessopen-test patch to skip a test until
    #1073071 is fixed. Closes: #1042737
  * Add the year 2024 to my debian/* copyright notice.
  * Declare compliance with Policy 4.7.0 with no changes.
  * Use X-DH-Compat instead of debian/compat.
  * Let debhelper add some default dependencies automatically.
  * New upstream version:
    - Closes: #1072590
    - stop excluding two files that were removed
    - add the upstream OpenPGP key
    - reset the repack suffix from dfsg2 to dfsg
    - update some patches to catch up with upstream changes:
      - 0015-Skip-dev-random-tests-on-hurd
      - 0017-alpha-fbfs-st_mtime
      - 0018-kfreebsd-ftbfs-utime-now
      - 0023-cmake-min-3.13
    - refresh the line numbers in some patches:
      - 0006-Use-bash-for-test-script-portablitity
      - 0013-skip-memory-greedy-tests

 -- Peter Pentchev <roam@debian.org>  Thu, 13 Jun 2024 16:32:12 +0300
